#include "../kdm2/header.h"
#include <fstream>
#define det3(matrix)(matrix[0][0]*matrix[1][1]*matrix[2][2]+matrix[0][1]*matrix[1][2]*matrix[2][0]+matrix[0][2]*matrix[1][0]*matrix[2][1]-matrix[0][2]*matrix[1][1]*matrix[2][0]-matrix[0][1]*matrix[1][0]*matrix[2][2]-matrix[0][0]*matrix[2][1]*matrix[1][2])
int main() {
    float **matrix = new float*[3];
    float *constants = new float[3];    
    for (int i=0;i<3;i++)matrix[i] = new float;
    ifstream file;
    std::string filename="input";
    file.open(filename);
    while(!file.is_open()){cout<<"Файлик "<<filename<<" не відкрився! Введіть назву файлу ще раз.";cin>>filename;file.open(filename);}
    for (short i=0;i<3;i++){for(short j=0;j<3;j++)file>>matrix[i][j];
        file>>constants[i];}
    file.close();
    display(matrix,3,2,"SLE:",constants);
    float D = det3(matrix);
    cout<<"detA = "<<D<<endl;
    cout<<"За методом Крамара..."<<endl;
    if (!D){cout<<"Неможливо розв'язати методом Крамера"<<std::endl;return 1;}
    
    float *solutions = new float;
    for (int i=0;i<3;i++) {
        float **tempMatrix=new float*[3];
        for (short j=0;j<3;j++) {
            tempMatrix[j]=new float;
            for (short k=0;k<3;k++)tempMatrix[j][k] = matrix[j][k];}
        for (short j=0;j<3;j++)tempMatrix[j][i] = constants[j];
        display(tempMatrix,3,2,"Розв'язуємо...");
        float Di=det3(tempMatrix);
        cout<<"det = "<<Di<<endl<<"Корінь x"<<i+1<<" = ";
        solutions[i] = det3(tempMatrix) / D;cout<<solutions[i]<<endl;
        for (int j = 0; j < 3; j++) {
            delete tempMatrix[j];
        }
        delete[]tempMatrix;
    }
    
    cout<<"Розв'язки системи рівнянь за Крамера:"<<endl<<std::setprecision(4);
    for (int i=1;i<4;i++)cout<<"x"<<i<<" = "<<solutions[i-1]<<endl;
    float **inverseMatrix = new float*[3];
    for (int i = 0; i < 3; i++) {
        inverseMatrix[i] = new float[3];
    }
    
    inverseMatrix[0][0] = (matrix[1][1] * matrix[2][2] - matrix[1][2] * matrix[2][1]) / D;
    inverseMatrix[0][1] = (matrix[0][2] * matrix[2][1] - matrix[0][1] * matrix[2][2]) / D;
    inverseMatrix[0][2] = (matrix[0][1] * matrix[1][2] - matrix[0][2] * matrix[1][1]) / D;
    inverseMatrix[1][0] = (matrix[1][2] * matrix[2][0] - matrix[1][0] * matrix[2][2]) / D;
    inverseMatrix[1][1] = (matrix[0][0] * matrix[2][2] - matrix[0][2] * matrix[2][0]) / D;
    inverseMatrix[1][2] = (matrix[0][2] * matrix[1][0] - matrix[0][0] * matrix[1][2]) / D;
    inverseMatrix[2][0] = (matrix[1][0] * matrix[2][1] - matrix[1][1] * matrix[2][0]) / D;
    inverseMatrix[2][1] = (matrix[0][1] * matrix[2][0] - matrix[0][0] * matrix[2][1]) / D;
    inverseMatrix[2][2] = (matrix[0][0] * matrix[1][1] - matrix[0][1] * matrix[1][0]) / D;
    
    display(inverseMatrix,3,2,"Обернена матриця A^(-1):");
    for (short i=0;i<3;i++) {solutions[i]=0;for (short j=0;j<3;j++)
        solutions[i]+=inverseMatrix[i][j]*constants[j];
        }
    cout << "Розв'язки системи рівнянь за Гауса-Жордана:" <<endl<<setprecision(4);
    for (short i=0;i<3;i++)cout<<'x'<<i+1<<" = "<<solutions[i]<<endl;
    delete solutions;
    delete[]constants;
    for (int i=0;i<3;i++){delete[]matrix[i];delete[]inverseMatrix[i];}delete[]matrix;delete[]inverseMatrix;
    return 0;
}
